// NB: only usable with ya automaton
/*@ ghost extern int aorai_CurStates; */

#define CONFIG_LEON
#include "leon.h"

/* sequence of calls and automaton state */
void calmos_hook(int choice)
{
  static int calmos_count = 0;
  static int calmos_scenario[20];
  static int calmos_state[20];
  Frama_C_show_each_calmos_count(calmos_count);
  /* register the current state */
    calmos_state[calmos_count] = aorai_CurStates;

  /* register the current call */
  calmos_scenario[calmos_count++]=choice;
  /* if current state is the same as the previous one, just abort the
     current execution path.
   */
  /*@ assert calmos_count > 1 ==>
       calmos_state[calmos_count-1] != calmos_state[calmos_count-2];  */
}

/* status of the hardware */
void register_status(unsigned int status) {
  static int status_count = 0;
  static unsigned int status_scenario[20];
  status_scenario[status_count++]=status;
  // we're not interested by hw errors
  /*@ assert (status & LEON_USTAT_ERROR) == 0; */ 
  return;
}
